; logic.asm - logic, conditionals, etc...



INVERT  ;( x1 -- x2 , Logical inverse )
        not     cell tosreg
        ret
end INVERT


_AND    ;( x1 x2 -- x3 )
        push    eax
        upop    eax
        and     tosreg, eax
        pop     eax
        ret
end _AND


_OR     ;( x1 x2 -- x3 )
        push    eax
        upop    eax
        or      tosreg, eax
        pop     eax
        ret
end _OR


_XOR    ;( x1 x2 -- x3 )
        push    eax
        upop    eax
        xor     tosreg, eax
        pop     eax
        ret
end _XOR


LSHIFT  ;( x1 u -- x2 , Left shift x1 by u bits )
        push    ecx
        upop    ecx
        shl     cell tosreg, cl
        pop     ecx
        ret
end LSHIFT


RSHIFT  ;( x1 u -- x2 , Right shift x1 by u bits [logical, not arithmetic] )
        push    ecx
        upop    ecx
        shr     cell tosreg, cl
        pop     ecx
        ret
end RSHIFT


_0EQUALS        ; 0= ( x -- flag , returns true if x=0 )
        cmp     cell tosreg, 0
        jz      .true
        mov     tosreg, cell 0
        jmp     .end
.true
        mov     tosreg, cell -1
.end
        ret
end _0EQUALS


_0NOT_EQUALS    ; 0<> ( x -- flag , returns true if x<>0 )
        cmp     cell tosreg, 0
        jz      .true
        mov     tosreg, cell 0
        jmp     .end
.true
        mov     tosreg, cell -1
.end
        ret
end _0NOT_EQUALS


_0LT            ; 0<
        cmp     cell tosreg, 0
        jl      .true
        mov     tosreg, cell 0
        jmp     .end
.true
        mov     tosreg, cell -1
.end
        ret
end _0LT


_0GT            ; 0>
        cmp     cell tosreg, 0
        jg      .true
        mov     tosreg, cell 0
        jmp     .end
.true
        mov     tosreg, cell -1
.end
        ret
end _0GT


EQUALS          ; = ( x1 x2 -- flag )
        push    eax

        upop    eax
        cmp     cell tosreg, eax
        je      .true
        mov     tosreg, cell 0
        jmp     .end
.true
        mov     tosreg, cell -1
.end
        pop     eax
        ret
end EQUALS


NOT_EQUALS      ; <> ( x1 x2 -- flag )
        push    eax

        upop    eax
        cmp     cell tosreg, eax
        jne     .true
        mov     tosreg, cell 0
        jmp     .end
.true
        mov     tosreg, cell -1
.end
        pop     eax
        ret
end NOT_EQUALS


LT
        push    eax

        upop    eax
        cmp     cell tosreg, eax
        jl      .true
        mov     tosreg, cell 0
        jmp     .end
.true
        mov     tosreg, cell -1
.end
        pop     eax
        ret
end LT


GT
        push    eax

        upop    eax
        cmp     cell tosreg, eax
        jg      .true
        mov     tosreg, cell 0
        jmp     .end
.true
        mov     tosreg, cell -1
.end
        pop     eax
        ret
end GT


LTE
        push    eax

        upop    eax
        cmp     cell tosreg, eax
        jle     .true
        mov     tosreg, cell 0
        jmp     .end
.true
        mov     tosreg, cell -1
.end
        pop     eax
        ret
end LTE


GTE
        push    eax

        upop    eax
        cmp     cell tosreg, eax
        jge     .true
        mov     tosreg, cell 0
        jmp     .end
.true
        mov     tosreg, cell -1
.end
        pop     eax
        ret
end GTE

