%include "regs.inc"

;Cell size macros

%ifdef PMODE
        CELLSIZE        equ     4       ;Size of a cell, in bytes
        CELLSHIFT       equ     2       ;Bit-shift to convert bytes <-> cells
        FIXSHIFT        equ     16      ;Fixed-point shift (Use 16.16)
        %define         dc      dd
        %define         cell    dword
        %define         movsc   movsd
        %define         resc    resd
        %define         ccd     cdq     ;"Convert cell to double-cell"
%else
        CELLSIZE        equ     2
        CELLSHIFT       equ     1
        FIXSHIFT        equ     6       ;(Use 10.6 fixed-point)
        %define         dc      dw
        %define         cell    word
        %define         movsc   movsw
        %define         resc    resw
        %define         ccd     cwd
%endif


;Stack macros
%macro upsh 1
        mov     [ebp], %1
        add     ebp, CELLSIZE
%endmacro

%macro upop 1
        sub     ebp, CELLSIZE
        mov     %1, [ebp]
%endmacro

%define tosreg  [ebp - CELLSIZE]
%define S0      [ebp - CELLSIZE]        ;Element on top of stack
%define S1      [ebp - 2*CELLSIZE]      ;2nd element on stack
%define S2      [ebp - 3*CELLSIZE]      ;...
%define S3      [ebp - 4*CELLSIZE]

%macro tos 1
        mov     %1, tosreg
%endmacro


%define f_immed         0x80
%define f_componly      0x40


;Parameters: label, "name", CFA, imm=0|1, link
%macro entry 5
        %1              ;Label
        dc %5           ;Link->next word
        db %%count|%4   ;Count (w/ flags: immediate, compile-only, etc...)
%%name
        db %2           ;Name
%%count equ ($-%%name)
        dc %3           ;Code Field Address (CFA)
        dc end_%3 - %3  ;Code Size
%endmacro

%macro end 1    ;Parameter: CFA
        end_%1
%endmacro

