; segments.inc

BOOTSEG equ 0x07C0      ;Where the BIOS puts the boot sector
INITSEG equ 0x9000      ;Where to move the boot sector to
SETUPSEG equ 0x9020     ;Where to load setup code (inits protected mode, etc)
SYSSEG  equ 0x1000      ;Where to load the kernel

;This file (automatically written after the kernel is created) tells
;how many blocks it is (as constant SYSSIZE)
%include "syssize.inc"

DSEG equ 0x2000         ;Where to relocate the data segment to
STACKSEG equ 0x3000     ;New stack segment
STACKSIZE equ 0x4000    ;Shared data/return stack -- total size
VIDSEG  equ 0xB800      ;Video memory segment

;Other stuff
STARTUP_BLOCK   equ 20

INBUF_SIZE      equ 80
NUM_BUFFERS     equ 4   ;Number of disk block buffers

